var browserify = require('browserify'),
    gulp = require('gulp'),
    sourcemaps = require('gulp-sourcemaps'),
    sass = require('gulp-sass'),
    autoprefixer = require('gulp-autoprefixer'),
    source = require('vinyl-source-stream'),
    buffer = require('vinyl-buffer'),
    browserSync = require('browser-sync'),
    sassLint = require('gulp-sass-lint'),
    browserDir = './public/',
    sassWatchPath = './scss/*.scss',
    htmlWatchPath = './public/*.html',
    rename = require('gulp-rename');

gulp.task('scss-lint', function() {
  return gulp.src('scss/*.scss')
    .pipe(sassLint({
      'config': './.scss-lint.yml'
    }))
    .pipe(sassLint.format())
    .pipe(sassLint.failOnError())
});

gulp.task('browser-sync', function() {
  var config = {
    server: {baseDir: browserDir}
  };
  return browserSync(config);
});

gulp.task('sass', function() {
  return gulp.src(sassWatchPath)
    .pipe(sourcemaps.init())
    .pipe(sass().on('error', sass.logError))
    .pipe(autoprefixer({
        browsers: ['last 2 versions']
    }))
    .pipe(sourcemaps.write())
    .pipe(gulp.dest('./public/assets/'))
    .pipe(rename('bascss.css'))
    .pipe(gulp.dest('./dist/'))
    .pipe(sass({ outputStyle: 'compressed', outFile: './dist/bascss.min.css' }))
    .pipe(rename('bascss.min.css'))
    .pipe(gulp.dest('./dist/'))
    .pipe(browserSync.reload({stream: true}));
});

gulp.task('watch', function() {
    gulp.watch(sassWatchPath, ['sass', 'scss-lint']);
    gulp.watch(htmlWatchPath, function() {
      return gulp.src('').pipe(browserSync.reload({stream: true}))
    });
});

gulp.task('builder', ['sass', 'scss-lint']);
gulp.task('watcher', ['watch', 'browser-sync']);
